<template>
  <main class="content">
    <div class="showroom-list">
      <nuxt-link
        v-if="pages.prev"
        :to="{ query: { showrooms: pages.prev } }"
        class="arrow-list prev-list"
        aria-label="Previous slide"
      >
        <i class="icon-arrow-slider_min"></i>
      </nuxt-link>
      <div class="scroll-list">
        <ul>
          <li
            v-for="(showroom, idx) in showrooms"
            :key="showroom.id"
            :class="{ active: currentIdx === idx }"
            @click="() => changeCurrentShowroom(idx)"
          >
            <button class="showroom-btn">{{ showroom.name }}</button>
          </li>
        </ul>
      </div>
      <nuxt-link
        v-if="pages.next"
        :to="{ query: { showrooms: pages.next } }"
        class="arrow-list next-list"
        aria-label="Next slide"
      >
        <i class="icon-arrow-slider_min"></i>
      </nuxt-link>
    </div>
    <div class="showroom-small">
      <div v-if="currentShowroom" class="showroom-scard">
        <base-avatar
          :src="currentShowroom.recommend_img"
          class="showroom-thumb"
        />
        <div class="showroom-name">{{ currentShowroom.name }}</div>
      </div>
    </div>
    <div class="comment-wrapper mt-4">
      <div class="comment-list">
        <ul>
          <base-comment
            v-for="(comment, idx) in comments.results"
            v-bind="comment"
            :id="idx"
            :key="comment.time_published + comment.showroom"
            :user_name="$store.state.auth.user.username"
            :avatar="$store.state.auth.user.avatar"
          />
        </ul>
        <base-pagination :total-pages="comments.count_pages" />
      </div>
    </div>
  </main>
</template>

<script>
export default {
  name: 'UserCommentsPage',
  layout: 'user',
  data() {
    return {
      showrooms: [],
      comments: {
        count_pages: 0,
        count: 0,
        links: {},
        results: [],
      },
      currentIdx: null,
      pages: {
        next: null,
        prev: null,
      },
    }
  },
  async fetch() {
    const responseShowrooms = await this.requestShowrooms({
      page: this.$route.query.showrooms,
    })

    this.pages = {
      next: responseShowrooms.links.next?.match(/(?<=page=)\d+/),
      prev:
        this.$route.query.showrooms > 1
          ? this.$route.query.showrooms - 1
          : null,
    }
    this.changeCurrentShowroom(0)
  },
  fetchOnServer: false,
  head() {
    return {
      title: this.$route.meta,
    }
  },
  computed: {
    currentShowroom() {
      return this.showrooms[this.currentIdx]
    },
  },
  watch: {
    // При смене страницы комментариев
    '$route.query.page'(page) {
      this.requestComments({ page })
    },
    // При смене страницы шоурумов
    '$route.query.showrooms'() {
      this.$fetch()
    },
  },
  methods: {
    async requestComments(query) {
      this.comments = await this.$store.dispatch('user/fetchShowroomComments', {
        id: this.showrooms[this.currentIdx].id,
        query,
      })
    },
    async requestShowrooms(query) {
      /**
       * @type {ResponseShowroomsCommentsList}
       */
      const showrooms = await this.$store.dispatch('user/fetchShowrooms', query)

      this.showrooms = showrooms.results
      return showrooms
    },
    changeCurrentShowroom(idx) {
      if (idx === this.currentIdx) return

      this.$router.push('')
      this.currentIdx = idx
      this.requestComments()
    },
  },
}
</script>

<style lang="less" src="@/assets/style/pages/cabinet/index.less"></style>
